Index: PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/Crossbar.vhd
===================================================================
--- PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/Crossbar.vhd	(revision 45)
+++ PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/Crossbar.vhd	(revision 65)
@@ -1,5 +1,5 @@
 ----------------------------------------------------------------------------------
 -- Company: 
--- Engineer: KIEGAING EMMANUEL
+-- Engineer: KIEGAING EMMANUEL / GAMOM NGOUNOU
 -- 
 -- Create Date:    11:48:18 06/19/2011 
@@ -16,5 +16,6 @@
 -- a été retiré les signaux inutilisées comme fp, port_source, etc...
 -- Revision 0.01 - File Created
--- Additional Comments: 
+-- Revision 0.02 Ajout des signaux clk et reset
+-- Additional Comments: pour la gestion du pipeline
 --
 ----------------------------------------------------------------------------------
@@ -33,7 +34,9 @@
     generic
 	      (
-			  number_of_crossbar_ports: positive := 4
+			  number_of_crossbar_ports: positive := 8
 			);
-    Port ( Port1_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
+    Port ( clk : in  STD_LOGIC;
+			  reset : in  STD_LOGIC; --pour gérer le pipeline
+			  Port1_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
            Port2_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
            Port3_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
@@ -115,13 +118,19 @@
 			  number_of_ports : positive := 4
 			);
-    Port ( Control : in  STD_LOGIC_VECTOR (number_of_ports*number_of_ports downto 1);
+    Port ( clk,reset : in std_logic;
+			  Control : in  STD_LOGIC_VECTOR (number_of_ports*number_of_ports downto 1);
            Data_In : in  STD_LOGIC_VECTOR (number_of_ports downto 1);
            Data_out : out  STD_LOGIC_VECTOR (number_of_ports downto 1));
 	END COMPONENT;	
-	
+signal ctrl_buf:	STD_LOGIC_VECTOR (number_of_crossbar_ports*number_of_crossbar_ports downto 1):=(others=>'0');
+--signal ctrl_chg:std_logic:='0';
 begin
 -- La matrice interconnectee
 -- le circuit genere depend du parametre generique nombre de ports
-
+--ctrl_chg<=all_zeros(ctrl_buf xor ctrl); --sur chaque changement du mot de contrôle, mettre à jour ce registre
+--ctrl_proc:process(ctrl)
+--	begin
+	ctrl_buf<=ctrl;
+--	end process;
 --======================crossbar 2 ports=======================
 
@@ -133,6 +142,8 @@
       GENERIC MAP(number_of_ports => 2)
       PORT MAP(
-
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+      
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -146,6 +157,8 @@
       GENERIC MAP(number_of_ports => 2)
       PORT MAP(
-
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -159,6 +172,8 @@
       GENERIC MAP(number_of_ports => 2)
       PORT MAP(
-
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -172,6 +187,8 @@
       GENERIC MAP(number_of_ports => 2)
       PORT MAP(
-
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -186,5 +203,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -199,5 +219,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -212,5 +234,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -225,5 +249,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -237,6 +263,8 @@
       GENERIC MAP(number_of_ports => 2)
       PORT MAP(
-
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -258,5 +286,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -272,6 +303,8 @@
       GENERIC MAP(number_of_ports => 3)
       PORT MAP(
-
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+      
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -288,5 +321,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -302,6 +337,8 @@
       GENERIC MAP(number_of_ports => 3)
       PORT MAP(
-
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+      
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -318,5 +355,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -333,5 +372,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -348,5 +389,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+      
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -362,6 +406,8 @@
       GENERIC MAP(number_of_ports => 3)
       PORT MAP(
-
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -377,6 +423,8 @@
       GENERIC MAP(number_of_ports => 3)
       PORT MAP(
-
-      Control => Ctrl,
+		reset => reset,
+		clk =>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -400,5 +448,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -417,5 +467,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -434,5 +486,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -451,5 +505,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -468,5 +524,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -485,5 +543,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -502,5 +562,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -519,5 +581,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -536,5 +600,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -560,5 +626,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -579,5 +647,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -598,5 +668,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -617,5 +689,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -636,5 +710,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -655,5 +731,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -674,5 +752,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -693,5 +773,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -712,5 +794,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -738,5 +822,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -759,5 +845,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -780,5 +868,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -801,5 +891,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -822,5 +914,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -843,5 +937,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -864,5 +960,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -885,5 +983,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -906,5 +1006,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -934,5 +1036,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -957,5 +1061,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -980,5 +1086,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -1003,5 +1111,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -1026,5 +1136,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -1049,5 +1161,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -1072,5 +1186,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -1095,5 +1211,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -1118,5 +1236,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -1147,6 +1267,8 @@
       GENERIC MAP(number_of_ports => 8)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+    
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -1172,6 +1294,8 @@
       GENERIC MAP(number_of_ports => 8)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+      
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -1197,6 +1321,8 @@
       GENERIC MAP(number_of_ports => 8)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+      
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -1222,6 +1348,8 @@
       GENERIC MAP(number_of_ports => 8)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -1247,6 +1375,8 @@
       GENERIC MAP(number_of_ports => 8)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -1272,6 +1402,8 @@
       GENERIC MAP(number_of_ports => 8)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -1297,6 +1429,8 @@
       GENERIC MAP(number_of_ports => 8)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -1322,6 +1456,8 @@
       GENERIC MAP(number_of_ports => 8)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+ 
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -1347,6 +1483,8 @@
       GENERIC MAP(number_of_ports => 8)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -1379,6 +1517,8 @@
       GENERIC MAP(number_of_ports => 9)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -1406,6 +1546,8 @@
       GENERIC MAP(number_of_ports => 9)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+    
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -1433,6 +1575,8 @@
       GENERIC MAP(number_of_ports => 9)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -1460,6 +1604,8 @@
       GENERIC MAP(number_of_ports => 9)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+ 
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -1487,6 +1633,8 @@
       GENERIC MAP(number_of_ports => 9)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+ 
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -1514,6 +1662,8 @@
       GENERIC MAP(number_of_ports => 9)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+ 
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -1541,6 +1691,8 @@
       GENERIC MAP(number_of_ports => 9)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+ 
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -1568,6 +1720,8 @@
       GENERIC MAP(number_of_ports => 9)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+     
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -1595,6 +1749,8 @@
       GENERIC MAP(number_of_ports => 9)
       PORT MAP(
-
-      Control => Ctrl,
+		clk =>clk,
+		reset =>reset,
+   
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -1630,5 +1786,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -1659,5 +1817,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -1688,5 +1848,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -1717,5 +1879,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -1746,5 +1910,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -1775,5 +1941,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -1804,5 +1972,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -1833,5 +2003,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -1862,5 +2034,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -1898,5 +2072,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -1929,5 +2105,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -1960,5 +2138,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -1991,5 +2171,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ clk=>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -2022,5 +2205,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -2053,5 +2238,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -2084,5 +2272,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -2115,5 +2306,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -2146,5 +2340,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -2184,5 +2381,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -2217,5 +2417,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -2250,5 +2453,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -2283,5 +2489,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -2316,5 +2525,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -2349,5 +2561,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -2382,5 +2597,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -2415,5 +2633,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -2448,5 +2669,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -2488,5 +2712,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -2523,5 +2749,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -2558,5 +2787,8 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -2593,5 +2825,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -2628,5 +2862,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -2663,5 +2899,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -2698,5 +2936,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -2733,5 +2973,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -2768,5 +3010,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -2810,5 +3054,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -2847,5 +3093,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -2884,5 +3132,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -2921,5 +3171,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -2958,5 +3210,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -2995,5 +3249,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -3032,5 +3288,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -3069,5 +3327,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -3106,5 +3366,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -3150,5 +3412,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -3189,5 +3453,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -3228,5 +3494,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -3267,5 +3535,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -3306,5 +3576,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -3345,5 +3617,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -3384,5 +3658,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -3423,5 +3699,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -3462,5 +3740,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
@@ -3508,5 +3788,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(0),
        Data_In(2) => Port2_in(0),
@@ -3549,5 +3831,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(1),
        Data_In(2) => Port2_in(1),
@@ -3590,5 +3874,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(2),
        Data_In(2) => Port2_in(2),
@@ -3631,5 +3917,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(3),
        Data_In(2) => Port2_in(3),
@@ -3672,5 +3960,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(4),
        Data_In(2) => Port2_in(4),
@@ -3713,5 +4003,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(5),
        Data_In(2) => Port2_in(5),
@@ -3754,5 +4046,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(6),
        Data_In(2) => Port2_in(6),
@@ -3795,5 +4089,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_in(7),
        Data_In(2) => Port2_in(7),
@@ -3836,5 +4132,7 @@
       PORT MAP(
 
-      Control => Ctrl,
+      reset => reset,
+ 	 	 clk=>clk,
+ 	 	 Control => Ctrl_buf,
        Data_In(1) => Port1_pulse_in,
        Data_In(2) => Port2_pulse_in,
